#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1200three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1200three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three12004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three12004xi = {
                1:'0x1164y-288z',
                2:'0x11y-1199z',
                3:'0x23y-1199z',
                4:'106x335y-1147z',
                5:'109x141y-1186z',
                6:'11x15y-1199z',
                7:'122x1163y-265z',
                8:'123x1006y-642z',
                9:'124x144y-1184z',
                10:'128x340y-1143z',
                11:'139x146y-1182z',
                12:'13x294y-1163z',
                13:'13x70y-1197z',
                14:'150x343y-1139z',
                15:'151x1079y-501z',
                16:'156x147y-1180z',
                17:'156x998y-816z',
                18:'16x1000y-662z',
                19:'172x146y-1178z',
                20:'173x345y-1136z',
                21:'176x1004y-632z',
                22:'183x1158y-253z',
                23:'189x144y-1176z',
                24:'194x920y-744z',
                25:'196x345y-1132z',
                26:'19x24y-1199z',
                27:'19x81y-1197z',
                28:'1x35y-1199z',
                29:'206x140y-1173z',
                30:'208x1075y-490z',
                31:'220x344y-1128z',
                32:'230x1000y-621z',
                33:'243x916y-735z',
                34:'244x1149y-241z',
                35:'245x341y-1123z',
                36:'266x1067y-479z',
                37:'269x337y-1119z',
                38:'27x91y-1196z',
                39:'284x992y-611z',
                40:'293x909y-725z',
                41:'294x330y-1115z',
                42:'29x31y-1199z',
                43:'304x1137y-229z',
                44:'30x304y-1160z',
                45:'319x322y-1110z',
                46:'323x1056y-468z',
                47:'337x982y-601z',
                48:'343x313y-1106z',
                49:'343x899y-716z',
                50:'364x1122y-218z',
                51:'368x301y-1101z',
                52:'36x101y-1195z',
                53:'379x1042y-457z',
                54:'37x1079y-523z',
                55:'390x968y-590z',
                56:'392x288y-1096z',
                57:'393x886y-706z',
                58:'39x38y-1198z',
                59:'3x47y-1199z',
                60:'3x5y-1199z',
                61:'416x273y-1091z',
                62:'423x1103y-206z',
                63:'435x1025y-446z',
                64:'442x871y-696z',
                65:'443x952y-580z',
                66:'46x110y-1194z',
                67:'47x314y-1157z',
                68:'481x1081y-194z',
                69:'490x1005y-435z',
                70:'490x852y-687z',
                71:'495x932y-569z',
                72:'50x44y-1198z',
                73:'538x1056y-182z',
                74:'538x831y-677z',
                75:'544x981y-423z',
                76:'546x910y-559z',
                77:'56x118y-1192z',
                78:'584x807y-667z',
                79:'593x1028y-170z',
                80:'596x885y-548z',
                81:'597x955y-412z',
                82:'61x1166y-276z',
                83:'62x49y-1197z',
                84:'630x781y-657z',
                85:'645x857y-537z',
                86:'647x997y-158z',
                87:'648x926y-401z',
                88:'66x322y-1153z',
                89:'674x752y-647z',
                90:'68x125y-1191z',
                91:'692x826y-527z',
                92:'698x894y-390z',
                93:'69x1004y-652z',
                94:'700x963y-146z',
                95:'717x720y-636z',
                96:'738x792y-516z',
                97:'747x859y-378z',
                98:'74x52y-1196z',
                99:'750x926y-135z',
                100:'759x685y-626z',
                101:'782x756y-505z',
                102:'793x821y-367z',
                103:'798x887y-123z',
                104:'799x649y-616z',
                105:'7x59y-1198z',
                106:'81x132y-1189z',
                107:'824x717y-494z',
                108:'836x610y-606z',
                109:'838x781y-355z',
                110:'844x844y-111z',
                111:'865x676y-483z',
                112:'86x329y-1150z',
                113:'880x738y-344z',
                114:'888x800y-99z',
                115:'903x633y-472z',
                116:'920x693y-332z',
                117:'930x753y-87z',
                118:'94x1081y-512z',
                119:'958x646y-321z',
                120:'95x137y-1188z',
                121:'968x703y-75z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1200three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1200three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE12000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE12000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE12000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE12000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE12000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three12004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE12000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE12000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE12000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three12004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three12004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE12000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE12000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE12000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1200three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                